<template>
  <div>
    <hr class="mt-3 mb-3" />
    <h1>Send Message and Store</h1>
    <v-form ref="form" @submit.prevent v-model="valid">
      <v-row>
        <v-col cols="12" sm="8">
          <v-text-field
            v-model="message"
            :rules="messageRules"
            @keyup.enter="submit"
            counter="50"
            placeholder="Enter your message to send to Slack here"
            prepend-inner-icon="mdi-message"
            outlined
            clearable
          ></v-text-field>
        </v-col>
        <v-col cols="12" sm="4">
          <v-btn
            block
            elevation="2"
            color="primary"
            large
            raised
            @click="submit"
            :disabled="!valid"
            >Send Message</v-btn
          >
        </v-col>
      </v-row>
    </v-form>
    <hr class="mt-3 mb-3" />
    <h1>List Messages</h1>
    <v-alert
      :value="backendAlert"
      border="left"
      color="red"
      elevation="5"
      type="error"
      transition="scale-transition"
      >Error reaching Backend service. Displaying test data.</v-alert
    >
    <v-card>
      <v-card-title>
        <v-text-field
          v-model="messageSearch"
          append-icon="mdi-magnify"
          label="Search"
          single-line
          hide-details
        ></v-text-field>
        <v-btn
          class="mx-2 ml-10"
          fab
          dark
          color="primary"
          :loading="dataLoading"
          :disabled="dataLoading"
          @click="refreshTable"
        >
          <v-icon dark>
            mdi-refresh
            <template v-slot:dataSlotLoader>
              <v-progress-circular indeterminate></v-progress-circular>
            </template>
          </v-icon>
        </v-btn>
      </v-card-title>
      <v-data-table
        :headers="headers"
        :items="messageList.messages"
        item-key="id"
        :items-per-page="50"
        :sort-by="timestamp"
        :sort-desc="true"
        :search="messageSearch"
        class="elevation-1"
      >
        <template v-slot:item.response="{ item }">
          <v-chip :color="getColor(item.response)" dark>
            {{ item.response }}
          </v-chip>
        </template>
      </v-data-table>
    </v-card>
  </div>
</template>

<script>
import axios from "axios";

export default {
  name: "Messaging",
  data: () => ({
    valid: true,
    backendAlert: false,
    dataLoading: false,
    message: "",
    messageSearch: "",
    timestamp: null,
    backendUrl: process.env.VUE_APP_API_BASE_URL,
    sendMessageResponse: null,
    messageList: [],
    sleepNow: (delay) => new Promise((resolve) => setTimeout(resolve, delay)),
    messageRules: [
      (v) => !!v || "Message is required",
      (v) => (v && v.length <= 50) || "Message must be less than 50 characters",
    ],
    headers: [
      { text: "GUID", value: "id" },
      { text: "Message", value: "message" },
      { text: "Slack Server Response", value: "response" },
      { text: "Timestamp", value: "timestamp" },
    ],
    pagination: {
      sortBy: "messageList.timestamp",
      sortDesc: true,
    },
  }),
  mounted() {
    this.refreshTable();
  },
  methods: {
    getColor(response) {
      if (response == "ok") return "green";
      else return "red";
    },

    submit() {
      if (this.$refs.form.validate()) {
        this.sendMessage();
        this.$refs.form.reset();
      }
    },
    async sendMessage() {
      let sendMessageUrl = `${this.backendUrl}/api/message?message=${this.message}`;
      await axios
        .get(sendMessageUrl)
        .then((response) => (this.sendMessageResponse = response.data))
        .then(() => this.refreshTable());
    },
    async refreshTable() {
      let getMessagesUrl = `${this.backendUrl}/api/messages`;
      this.dataLoading = true;
      // await this.sleepNow(2000);
      await axios
        .get(getMessagesUrl)
        .then((this.backendAlert = false))
        .then((response) => (this.messageList = response.data))
        .then((this.dataLoading = false))
        .catch(
          () => (
            (this.backendAlert = true),
            (this.messageList = {
              messages: [
                {
                  id: "525d0bb8-f7d6-492e-bdb2-74cb0a56b632",
                  message: "Hats",
                  response: "FAKED DATA",
                  timestamp: "Wed, 18 Nov 2020 07:37:09 GMT",
                },
                {
                  id: "a6c9dd75-fbcc-4d7c-8071-69b860a6577e",
                  message: "Hello",
                  response: "FAKED DATA",
                  timestamp: "Wed, 19 Nov 2020 07:39:29 GMT",
                },
                {
                  id: "2d6a992c-58b5-40b5-bec0-df220ed271a9",
                  message: "Hi",
                  response: "FAKED DATA",
                  timestamp: "Wed, 20 Nov 2020 07:53:58 GMT",
                },
              ],
            }),
            (this.dataLoading = false)
          )
        );
    },
  },
};
</script>

<style>
.custom-loader {
  animation: loader 1s infinite;
  display: flex;
}
@-moz-keyframes loader {
  from {
    transform: rotate(0);
  }
  to {
    transform: rotate(360deg);
  }
}
@-webkit-keyframes loader {
  from {
    transform: rotate(0);
  }
  to {
    transform: rotate(360deg);
  }
}
@-o-keyframes loader {
  from {
    transform: rotate(0);
  }
  to {
    transform: rotate(360deg);
  }
}
@keyframes loader {
  from {
    transform: rotate(0);
  }
  to {
    transform: rotate(360deg);
  }
}
</style>
